

void updatePixel()
// updates Pixel values according to their channel[x] value

{
  //Serial.println(F("D008 Update Pixel"));
  for (byte i=0; i<maxChannels; i++)
  {
     if (isBlackout)
     {
      strip.setPixelColor(i, 0,0,0);
     }
     else
     {
      strip.setPixelColor(i, r_channel[i]*master/100,g_channel[i]*master/100,b_channel[i]*master/100);  
     }
     //Serial.print(F("D012 channel:"));Serial.print(i);
     //Serial.print(F(" red:"));Serial.print(r_channel[i]);
     //Serial.print(F(" green:"));Serial.print(g_channel[i]);
     //Serial.print(F(" blue:"));Serial.println(b_channel[i]);
  }
  strip.show();
}


void fadePixel()
//Fade: 
// if the value is even, we go up
// if the value is odd, we go down
{
  //Serial.println(F("D035 Pattern Fade"));
  const byte myStep=4;              //only use even values 2,4,8 ... 
  for (int j = 0; j<maxChannels; j++)                        
  {
      if (r_channel[j]%2==0)          //0 up; 1 down
      {
        if (r_channel[j]<255-myStep)
        {
          r_channel[j]=r_channel[j]+myStep;  
        }
        else
        {
          if (r_channel[j]>=255-myStep) {r_channel[j]=255;}     // Higher End: Switch over to odd values
          r_channel[j]=r_channel[j]-myStep;                     // so theoretical maximum is 255-4=251
        }
      }
      else
      {
        if (r_channel[j]>myStep)
        {
          r_channel[j]=r_channel[j]-myStep;  
        }
        else
        {
          if (r_channel[j]<=myStep){r_channel[j]=0;}           // Lower End: Switch over to even values
          r_channel[j]=r_channel[j]+myStep;                    // so theoretical minimum is 0+4=4
        }
      }
      //Serial.print (F("D060 ")); Serial.print (j); Serial.print (F("r: ")); Serial.println(channel[j]);
  }
  for (int j = 0; j<maxChannels; j++)                        
  {
      if (g_channel[j]%2==0)          //0 up; 1 down
      {
        if (g_channel[j]<255-myStep)
        {
          g_channel[j]=g_channel[j]+myStep;  
        }
        else
        {
          if (g_channel[j]>=255-myStep) {g_channel[j]=255;}     // Higher End: Switch over to odd values
          g_channel[j]=g_channel[j]-myStep;                     // so theoretical maximum is 255-4=251
        }
      }
      else
      {
        if (g_channel[j]>myStep)
        {
          g_channel[j]=g_channel[j]-myStep;  
        }
        else
        {
          if (g_channel[j]<=myStep){g_channel[j]=0;}           // Lower End: Switch over to even values
          g_channel[j]=g_channel[j]+myStep;                    // so theoretical minimum is 0+4=4
        }
      }
      //Serial.print (F("D088 ")); Serial.print (j); Serial.print (F("g: ")); Serial.println(g_channel[j]);
  }
  for (int j = 0; j<maxChannels; j++)                        
  {
      if (b_channel[j]%2==0)          //0 up; 1 down
      {
        if (b_channel[j]<63-myStep)
        {
          b_channel[j]=b_channel[j]+myStep;  
        }
        else
        {
          if (b_channel[j]>=63-myStep) {b_channel[j]=63;}     // Higher End: Switch over to odd values
          b_channel[j]=b_channel[j]-myStep;                     // so theoretical maximum is 255-4=251
        }
      }
      else
      {
        if (b_channel[j]>myStep)
        {
          b_channel[j]=b_channel[j]-myStep;  
        }
        else
        {
          if (b_channel[j]<=myStep){b_channel[j]=0;}           // Lower End: Switch over to even values
          b_channel[j]=b_channel[j]+myStep;                    // so theoretical minimum is 0+4=4
        }
      }
      //Serial.print (F("D116 ")); Serial.print (j); Serial.print (F("b: ")); Serial.println(b_channel[j]);
  }
  updatePixel();
}


void pattern2()
// Seefahrt: rot/grün mit einem schnell durchfahrenden Highpoint 
//           vom Tor zum Haus
// Eine einzige Schleife ändert auch den Twin
{
  //Serial.println(F("D127 Pattern2 Seefahrt"));
  const byte myPixels = 10;         // Length of pathway
  const byte high = 255;            // dimmer value for high pixel
  const byte medium = 128;          // dimmer value for medium pixel
  const byte low = 42;              // dimmer value for low dimmed pixel
  counterPattern++;
  if (counterPattern>=myPixels) {counterPattern=0;}
  
  for (int j = myPixels; j>=1; j--)                        
  {
      uint16_t twin=myPixels*2+1-j; 
      
      r_channel[j]=0;   
      if (myPixels-counterPattern==j) 
      { g_channel[j]=high;
        r_channel[twin]=high;
      }
      else 
      { g_channel[j]=low;  
        r_channel[twin]=low;
      }
      b_channel[j]=0;    
      g_channel[twin]=0;
      b_channel[twin]=0;         
            
      //Serial.print (F("D135 ")); Serial.print (j); Serial.print (F("r: ")); Serial.println(r_channel[j]);
  }
  if(counterPattern%2)                       //Status LED 0 blink
  {
    r_channel[0]=high; g_channel[0]=0; b_channel[0]=0;
  }
  else
  {
    r_channel[0]=0; g_channel[0]=high; b_channel[0]=0;
  }
  updatePixel(); 
  updatePixel();
}

void pattern3()
// Seefahrt: rot/grün mit einem schnell durchfahrenden Highpoint 
//           vom Haus nach draußen
// Zwei separate Schleifen

{
  //Serial.println(F("D127 Pattern2 Seefahrt"));
  const byte myPixels=10;           //Length of pathway
  const byte high = 255;            //dimmer value for high pixel
  const byte medium = 128;             //dimmer value for medium pixel
  const byte low = 42;              //dimmer value for low dimmed pixel
  counterPattern++;
  if (counterPattern>myPixels) {counterPattern=0;}
  
  for (int j = 1; j<=myPixels; j++)                        
  {
      if (counterPattern==j) r_channel[j]=high; else r_channel[j]=low;  
      g_channel[j]=0;
      b_channel[j]=0;          
      //Serial.print (F("D135 ")); Serial.print (j); Serial.print (F("r: ")); Serial.println(r_channel[j]);
  }

  for (int j = myPixels*2; j>myPixels; j--)                        
  {
      r_channel[j]=0;  
      if (myPixels*2+1 - counterPattern==j) g_channel[j]=high; else g_channel[j]=low;
      b_channel[j]=0;          
      //Serial.print (F("D143 ")); Serial.print (j); Serial.print (F("g: ")); Serial.println(g_channel[j]);
  }  
  if(counterPattern%2)                       //Status LED 0 blink
  {
    r_channel[0]=high; g_channel[0]=0; b_channel[0]=0;
  }
  else
  {
    r_channel[0]=0; g_channel[0]=high; b_channel[0]=0;
  }
  updatePixel();  
}


void pattern4()
// Autobahn: rot/weiß mit einem schnell durchfahrenden Highpoint 
//           vom Tor zum Haus
// Technischer Unterschied von Pattern 2: Wir setzen zunächst alle Pixel auf low und dann nur den betroffenen auf high
{
  const byte myPixels=10;           //Length of pathway
  const byte high = 255;            //dimmer value for high pixel
  const byte medium = 150;          //dimmer value for medium pixel
  const byte low = 42;              //dimmer value for low dimmed pixel
  counterPattern++;
  if (counterPattern>myPixels) {counterPattern=0;}
  //Serial.print  (F("D243 Pattern5 Autobahn counterPattern:")); Serial.println(counterPattern);
  for (int j = 1; j<=myPixels; j++)                        
  {
      r_channel[j]=low;          g_channel[j]=0;        b_channel[j]=0;   
      r_channel[myPixels+j]=low; g_channel[myPixels+j]=low; b_channel[myPixels+j]=low/2;         // Gegenrichtung
  }
  r_channel[counterPattern+1]=high;           g_channel[counterPattern+1]=0;              b_channel[counterPattern+1]=0;
  r_channel[myPixels*2-counterPattern]= high; g_channel[myPixels*2-counterPattern]= high; b_channel[myPixels*2-counterPattern]= high/2;
  if (counterPattern+1>2)                     //Precessor - Vorgänger Pixel (Richtung Haus)
  { 
    r_channel[counterPattern]=medium;              g_channel[counterPattern]=0;                   b_channel[counterPattern]=0; 
    r_channel[myPixels*2-counterPattern+1]=medium; g_channel[myPixels*2-counterPattern+1]=medium; b_channel[myPixels*2-counterPattern+1]=medium/2;
  }
  if (counterPattern<myPixels-1)             //Successor - Nachfolger Pixel (Richtung Gartentor)
  {
    r_channel[counterPattern+2]=medium;            g_channel[counterPattern+2]=0;                 b_channel[counterPattern+2]=0;
    r_channel[myPixels*2-counterPattern-1]=medium; g_channel[myPixels*2-counterPattern-1]=medium; b_channel[myPixels*2-counterPattern-1]=medium/2;  
  }
  if(counterPattern%2)                       //Status LED 0 blink
  {
    r_channel[0]=high; g_channel[0]=0; b_channel[0]=0;
  }
  else
  {
    r_channel[0]=high; g_channel[0]=high; b_channel[0]=high/2;
  }
  updatePixel();
}


void pattern5()
// Autobahn: rot/weiß mit einem schnell durchfahrenden Highpoint 
//           vom Tor zum Haus
// Technischer Unterschied von Pattern 2: Wir setzen zunächst alle Pixel auf low und dann nur den betroffenen auf high
{
  const byte myPixels=10;           //Length of pathway
  const byte high = 255;            //dimmer value for high pixel
  const byte medium = 150;          //dimmer value for medium pixel
  const byte low = 42;              //dimmer value for low dimmed pixel
  if (counterPattern<=0) {counterPattern=myPixels;}
  counterPattern--;
  //Serial.print  (F("D243 Pattern5 Autobahn counterPattern:")); Serial.println(counterPattern);
  for (int j = 1; j<=myPixels; j++)                        
  {
      r_channel[j]=low;          g_channel[j]=low;        b_channel[j]=low/2;   
      r_channel[myPixels+j]=low; g_channel[myPixels+j]=0; b_channel[myPixels+j]=0;         // Gegenrichtung
  }
  r_channel[counterPattern+1]=high;g_channel[counterPattern+1]=high;b_channel[counterPattern+1]=high/2;
  r_channel[myPixels*2-counterPattern]= high; g_channel[myPixels*2-counterPattern]= 0; b_channel[myPixels*2-counterPattern]= 0;
  if (counterPattern+1>2)                     //Precessor - Vorgänger Pixel (Richtung Haus)
  { 
    r_channel[counterPattern]=medium;g_channel[counterPattern]=medium;b_channel[counterPattern]=medium/2; 
    r_channel[myPixels*2-counterPattern+1]=medium;g_channel[myPixels*2-counterPattern+1]=0;b_channel[myPixels*2-counterPattern+1]=0;
  }
  if (counterPattern<myPixels-1)             //Successor - Nachfolger Pixel (Richtung Gartentor)
  {
    r_channel[counterPattern+2]=medium;g_channel[counterPattern+2]=medium;b_channel[counterPattern+2]=medium/2;
    r_channel[myPixels*2-counterPattern-1]=medium;g_channel[myPixels*2-counterPattern-1]=0;b_channel[myPixels*2-counterPattern-1]=0;  
  }
  if(counterPattern%2)                       //Status LED 0 blink
  {
    r_channel[0]=high; g_channel[0]=0; b_channel[0]=0;
  }
  else
  {
    r_channel[0]=high; g_channel[0]=high; b_channel[0]=high/2;
  }
  updatePixel();
}

void pattern6()
// Reinhold: beidseitig weiß mit einem schnell durchfahrenden Highpoint ohne dass die alten wieder gedimmt werden
//           vom Tor zum Haus
// 
{
  const byte myPixels=10;           // Length of pathway
  const byte high = 255;            // dimmer value for high pixel
  const byte medium = 150;          // dimmer value for medium pixel
  const byte low = 42;              // dimmer value for low dimmed pixel

  //Serial.print  (F("D298 Pattern6 weiß counterPattern:")); Serial.println(counterPattern);
  for (int j = 1; j<=myPixels-counterPattern; j++)                        
  {
    r_channel[j]=low;              g_channel[j]=low;              b_channel[j]=low/2;   
    r_channel[myPixels*2-j+1]=low; g_channel[myPixels*2-j+1]=low; b_channel[myPixels*2-j+1]=low/2;         // Gegenrichtung
  }
  for (int j = myPixels-counterPattern; j<=myPixels; j++)                        
  {  
    r_channel[j]=high;              g_channel[j]=high;              b_channel[j]=high/2;
    r_channel[myPixels*2-j+1]=high; g_channel[myPixels*2-j+1]=high; b_channel[myPixels*2-j+1]=high/2;
  }
  
  if(counterPattern%2)                       //Status LED 0 blink
  {
    r_channel[0]=low; g_channel[0]=low; b_channel[0]=low/2;
  }
  else
  {
    r_channel[0]=high; g_channel[0]=high; b_channel[0]=high/2;
  }
  updatePixel();
  counterPattern++;
  if (counterPattern>myPixels) {counterPattern=0;}
}

void pattern7()
// Reinhold: beidseitig weiß mit einem schnell durchfahrenden Highpoint ohne dass die alten wieder gedimmt werden
//           vom Haus zum Tor
// 
{
  const byte myPixels=10;           // Length of pathway
  const byte high = 255;            // dimmer value for high pixel
  const byte medium = 150;          // dimmer value for medium pixel
  const byte low = 42;              // dimmer value for low dimmed pixel

  //Serial.print  (F("D333 Pattern7 weiß counterPattern:")); Serial.println(counterPattern);
  for (int j = 1; j<=myPixels-counterPattern; j++)                        
  {
    r_channel[j]=high;              g_channel[j]=high;              b_channel[j]=high/2;   
    r_channel[myPixels*2-j+1]=high; g_channel[myPixels*2-j+1]=high; b_channel[myPixels*2-j+1]=high/2;         // Gegenrichtung
  }
  for (int j = myPixels-counterPattern+1; j<=myPixels; j++)                        
  {  
    r_channel[j]=low;              g_channel[j]=low;              b_channel[j]=low/2;
    r_channel[myPixels*2-j+1]=low; g_channel[myPixels*2-j+1]=low; b_channel[myPixels*2-j+1]=low/2;
  }
  
  if(counterPattern%2)                       //Status LED 0 blink
  {
    r_channel[0]=low; g_channel[0]=low; b_channel[0]=low/2;
  }
  else
  {
    r_channel[0]=high; g_channel[0]=high; b_channel[0]=high/2;
  }
  updatePixel();
  if (counterPattern<=0) {counterPattern=myPixels;}
  counterPattern--;
}





void insertByte(byte total, unsigned int startAddr, unsigned int maxAddr)
// insert total bytes from startAddr 
// shift bytes to right and don't exceed the maxAddr
{
   for (unsigned int actual = maxAddr; actual>=startAddr+total; actual--)
   {
      EEPROM.write(actual,EEPROM.read(actual-total));
   }
   EEPROM.commit();
   //die eingefügten Stellen bleiben ungelöscht, weil sie eigentlich eh in kürze mit Echten Daten beschrieben werden müssten.
  
}

void deleteByte(byte total, unsigned int startAddr, unsigned int maxAddr)
// delete total bytes from startAddr 
// shift bytes up to maxAddr to left
{
   for (unsigned int actual = startAddr; actual<=maxAddr-total; actual++)
   {
      EEPROM.write(actual,EEPROM.read(actual+total));
   }
   //delete the rightmost total bytes
   for (unsigned int actual = maxAddr-total; actual<=maxAddr; actual++)
   {
      EEPROM.write(actual,0);
   }
   EEPROM.commit();
}

int getSceneAddr(byte wanted)
{
  //int result=-1;
  unsigned int actual=addrScene;
  if (wanted>0)
  {
    for (unsigned int i = 1;  i<=wanted; i++)
    {
      actual=actual+1+8+EEPROM.read(actual)*4;         //1length + 8memo + length*4
      if (actual<addrSequence && i>sceneCache) {sceneCache=i;}                       // cache the "last" scene number
    }
  }
  //Serial.print(F("D086 getSceneAddr("));Serial.print(wanted);Serial.print(F(") "));Serial.println(actual);
  //MISSING: absichern gegen unter addrScene und über addrSequence-255
  return actual;
}


void saveScene(byte actual)
// save actual channel setting as Scene and save to EEPROM
// save only values <>0 to spare EEPROM memory
{
  
  byte newLength = 0;
  unsigned int myPosition = 0;
  //Länge ermitteln
  for (unsigned int j = 0; j<=maxChannels; j++)                        
  {
    if (r_channel[j]>0 || g_channel[j]>0 || b_channel[j]>0)
    {
      newLength++;
    }
  }
  //my Position ermitteln
  myPosition = getSceneAddr(actual);
  
  //evtl Platz anpassen
  byte oldLength=EEPROM.read(myPosition);
  if (oldLength<newLength)
  { 
    insertByte((newLength-oldLength)*4, myPosition+1+8, addrSequence-1);
  }
  else if (oldLength>newLength)
  {
    deleteByte((oldLength-newLength)*4, myPosition+1+8, addrSequence-1);
  }
  
  //speichern
  EEPROM.write(myPosition,newLength);
 
  unsigned int i = 0;  
  for (unsigned int j = 0; j<=maxChannels; j++)                        
  {
    if (r_channel[j]>0 || g_channel[j]>0 || b_channel[j]>0)       // at least one color must be set
    {
      EEPROM.write((myPosition+1+8)+i*4,j);
      EEPROM.write((myPosition+1+8)+i*4+1,r_channel[j]);
      EEPROM.write((myPosition+1+8)+i*4+2,g_channel[j]);
      EEPROM.write((myPosition+1+8)+i*4+3,b_channel[j]);
      i++;
    }
  }
  EEPROM.commit();
  Serial.print(F("D110 newLength "));Serial.print(newLength);Serial.print(F("| oldLength "));Serial.println(oldLength);
}

void loadScene(byte actual)
// Load scene from EEPROM and display
{
  unsigned int myPosition = 0;
  
  //my Position ermitteln
  //myPosition = addrScene;
  myPosition = getSceneAddr(actual);

  //Länge lesen
  byte myLength=EEPROM.read(myPosition);

  memset(r_channel,0,sizeof(r_channel)); 
  memset(g_channel,0,sizeof(g_channel)); 
  memset(b_channel,0,sizeof(b_channel)); 
  unsigned int i=0;
  for (i = 0; i<myLength; i++)                        //no local i because want to have a debug print afterwards
  {
      r_channel[EEPROM.read((myPosition+1+8)+i*4)]=EEPROM.read((myPosition+1+8)+i*4+1);
      g_channel[EEPROM.read((myPosition+1+8)+i*4)]=EEPROM.read((myPosition+1+8)+i*4+2);
      b_channel[EEPROM.read((myPosition+1+8)+i*4)]=EEPROM.read((myPosition+1+8)+i*4+3);
  }
  //Serial.print(F("D184 myLength "));Serial.print(myLength);Serial.print(F("| stored pairs "));Serial.println(i);
  updatePixel();
}




